diff -uNr PDFlib-Lite-7.0.4/libs/pdflib/p_type1.c PDFlib-Lite-7.0.5/libs/pdflib/p_type1.c
--- PDFlib-Lite-7.0.4/libs/pdflib/p_type1.c	2009-06-08 17:57:30.000000000 +0200
+++ PDFlib-Lite-7.0.5/libs/pdflib/p_type1.c	2010-04-29 15:50:07.000000000 +0200
@@ -10,29 +10,48 @@
  |                                                                           |
  *---------------------------------------------------------------------------*/
 
-/* $Id: p_type1.c,v 1.93.2.25 2009/03/27 14:40:09 kurt Exp $
+/* $Id: p_type1.c,v 1.93.2.30 2010/04/23 09:47:22 kurt Exp $
  *
  * PDFlib Type1 font handling routines
  *
  */
 
-#include "pc_ctype.h"
 
 #include "p_intern.h"
 #include "p_font.h"
 
+#include "pc_ctype.h"
+#include "pc_strconst.h"
+#include "pc_string.h"
+
 
 /* Type 1 font portions: ASCII, encrypted, zeros */
-typedef enum { t1_ascii, t1_encrypted, t1_zeros } pdf_t1portion;
+typedef enum
+{
+    t1_ascii,
+    t1_encrypted,
+    t1_zeros,
+    t1_eof
+}
+pdf_t1portion;
 
-typedef struct {
+static const pdc_keyconn pdf_t1portion_keylist[] =
+{
+    {"ascii",      t1_ascii},
+    {"encrypted",  t1_encrypted},
+    {"zeros",      t1_zeros}
+};
+
+typedef struct
+{
     pdf_t1portion  portion;
     size_t         length[4];
     pdc_file      *fontfile;
     pdc_byte      *img;            /* in-core Type1 font file image   */
     pdc_byte      *end;            /* first byte above image buf   */
     pdc_byte      *pos;            /* current "file" position      */
-} t1_private_data;
+}
+t1_private_data;
 
 #define PFA_TESTBYTE    4
 
@@ -41,7 +60,6 @@
 
 /* ---------------------------- General platforms --------------------------- */
 
-#define LINEBUFLEN      256
 
 /*
  * PFA files are assumed to be encoded in host format. Therefore
@@ -53,6 +71,7 @@
 PFA_data_fill(PDF *p, PDF_data_source *src)
 {
     static const char *fn = "PFA_data_fill";
+    pdc_bool logg6 = pdc_logg_is_enabled(p->pdc, 6, trc_font);
 #ifndef PDFLIB_EBCDIC
     static const char HexToBin['F' - '0' + 1] = {
         0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 0, 0, 0, 0, 0, 0,
@@ -63,19 +82,26 @@
     char *s, *c;
     int i;
     int len;
-    t1_private_data *t1_private;
+    t1_private_data *t1;
     pdf_t1portion t1portion;
 
-    t1_private = (t1_private_data *) src->private_data;
+    t1 = (t1_private_data *) src->private_data;
+
+    if (t1->portion == t1_eof)
+        return pdc_false;
 
     if (src->buffer_start == NULL)
     {
-        src->buffer_start = (pdc_byte *) pdc_malloc(p->pdc, LINEBUFLEN + 1, fn);
-        src->buffer_length = LINEBUFLEN;
+        src->buffer_start = (pdc_byte *)
+                                pdc_malloc(p->pdc, PDC_BUFSIZE + 1, fn);
+        src->buffer_length = PDC_BUFSIZE;
     }
 
-    s = pdc_fgetline((char *) src->buffer_start, LINEBUFLEN,
-                     t1_private->fontfile);
+    if (logg6)
+        pdc_logg(p->pdc, "\t\t\tdata fill: portion=%s\n",
+                 pdc_get_keyword(t1->portion, pdf_t1portion_keylist));
+
+    s = pdc_fgetline((char *) src->buffer_start, PDC_BUFSIZE, t1->fontfile);
     if (s == NULL)
         return pdc_false;
 
@@ -93,22 +119,34 @@
             /* */ ;
         }
         if (s[i] == '\n')
-            t1_private->portion = t1_zeros;
+        {
+            t1->portion = t1_zeros;
+
+            if (logg6)
+                pdc_logg(p->pdc, "\t\t\tlinefeed detected: set portion %s\n",
+                         pdc_get_keyword(t1->portion,
+                                         pdf_t1portion_keylist));
+        }
     }
 
     /* check whether font data portion follows: set t1_encrypted flag later */
-    t1portion = t1_private->portion;
-    if (t1_private->portion != t1_encrypted &&
+    t1portion = t1->portion;
+    if (t1->portion != t1_encrypted &&
         !strncmp((const char *)s, PDF_CURRENTFILE, strlen(PDF_CURRENTFILE)))
+    {
         t1portion = t1_encrypted;
 
+        if (logg6)
+            pdc_logg(p->pdc, "\t\t\t\"%s\" detected\n", PDF_CURRENTFILE);
+    }
+
     src->next_byte = src->buffer_start;
 
-    switch (t1_private->portion)
+    switch (t1->portion)
     {
         case t1_ascii:
         {
-            t1_private->length[1] += (size_t) len;
+            t1->length[1] += (size_t) len;
             src->bytes_available = (size_t) len;
         }
         break;
@@ -129,27 +167,33 @@
                 if ((!pdc_isxdigit(s[i]) && !pdc_isspace(s[i])) ||
                     (!pdc_isxdigit(s[i+1]) && !pdc_isspace(s[i+1])))
                 {
-                    pdc_fclose(t1_private->fontfile);
-                    pdc_error(p->pdc, PDF_E_FONT_CORRUPT, "PFA", "", 0, 0);
+                    pdc_fclose(t1->fontfile);
+                    pdc_error(p->pdc, PDF_E_FONT_CORRUPT_PFA, 0, 0, 0, 0);
                 }
                 s[i/2] = (char) (16*HexToBin[s[i]-'0'] + HexToBin[s[i+1]-'0']);
 
                 src->bytes_available++;
             }
-            t1_private->length[2] += src->bytes_available;
+            t1->length[2] += src->bytes_available;
         }
         break;
 
         case t1_zeros:
         {
-            t1_private->length[3] += (size_t) len;
+            t1->length[3] += (size_t) len;
             src->bytes_available = (size_t) len;
         }
         break;
+
+        default:
+        break;
     }
 
-    t1_private->portion = t1portion;
+    t1->portion = t1portion;
 
+    if (logg6)
+        pdc_logg(p->pdc, "\t\t\tset portion %s\n",
+                 pdc_get_keyword(t1->portion, pdf_t1portion_keylist));
     return pdc_true;
 }
 
@@ -274,16 +318,16 @@
 static void
 t1data_init(PDF *p, PDF_data_source *src)
 {
-    t1_private_data *t1_private;
+    t1_private_data *t1;
 
     (void) p;
 
-    t1_private = (t1_private_data *) src->private_data;
+    t1 = (t1_private_data *) src->private_data;
 
-    t1_private->portion = t1_ascii;
-    t1_private->length[1] = (size_t) 0;
-    t1_private->length[2] = (size_t) 0;
-    t1_private->length[3] = (size_t) 0;
+    t1->portion = t1_ascii;
+    t1->length[1] = (size_t) 0;
+    t1->length[2] = (size_t) 0;
+    t1->length[3] = (size_t) 0;
 
     src->buffer_start = NULL;
 }
@@ -294,7 +338,7 @@
                     PDF_data_source *t1src, pdc_bool requested)
 {
     static const char *fn = "pdf_t1open_fontfile";
-    t1_private_data  *t1_private = NULL;
+    t1_private_data  *t1 = NULL;
     pdc_file *fp = NULL;
     const char *stemp = NULL;
     pdc_byte magic[PFA_TESTBYTE];
@@ -364,32 +408,33 @@
     {
         t1src->private_data = (unsigned char *)
                 pdc_malloc(p->pdc, sizeof(t1_private_data), fn);
-        t1_private = (t1_private_data *) t1src->private_data;
+        t1 = (t1_private_data *) t1src->private_data;
 
         if (filename)
         {
             pdc_fclose(fp);
             if (ispfb)
             {
-                t1_private->fontfile =
+                t1->fontfile =
                     pdc_fsearch_fopen(p->pdc, fullname, NULL, "PFB ", fflags);
             }
             else
             {
-                t1_private->fontfile =
+                t1->fontfile =
                     pdc_fsearch_fopen(p->pdc, fullname, NULL, "PFA ",
                                       PDC_FILE_TEXT);
             }
 
-            if (t1_private->fontfile == NULL)
+            if (t1->fontfile == NULL)
                 PDC_RETHROW(p->pdc);
         }
         else if (font->ft.img)
         {
-            t1_private->fontfile = NULL;
-            t1_private->img = font->ft.img;
-            t1_private->pos = font->ft.img;
-            t1_private->end = font->ft.img + font->ft.filelen;
+            /* only for virtual PFB files */
+            t1->fontfile = NULL;
+            t1->img = font->ft.img;
+            t1->pos = font->ft.img;
+            t1->end = font->ft.img + font->ft.filelen;
         }
 
         t1src->init = t1data_init;
diff -uNr PDFlib-Lite-7.0.4/libs/pdflib/p_type3.c PDFlib-Lite-7.0.5/libs/pdflib/p_type3.c
--- PDFlib-Lite-7.0.4/libs/pdflib/p_type3.c	2009-06-08 17:57:30.000000000 +0200
+++ PDFlib-Lite-7.0.5/libs/pdflib/p_type3.c	2010-04-29 15:50:07.000000000 +0200
@@ -10,7 +10,7 @@
  |                                                                           |
  *---------------------------------------------------------------------------*/
 
-/* $Id: p_type3.c,v 1.120.2.12 2009/01/08 19:32:18 kurt Exp $
+/* $Id: p_type3.c,v 1.120.2.14 2009/07/30 16:52:33 kurt Exp $
  *
  * Routines for Type 3 (user-defined) fonts
  *
@@ -573,6 +573,7 @@
     pdf_font *font;
     pdf_t3font *t3font;
     pdf_t3glyph *glyph = NULL;
+    pdc_scalar tbc;
     int ig;
 
     if (glyphname == NULL || *glyphname == '\0')
@@ -613,6 +614,21 @@
              urx != 0 || ury != 0))
             pdc_error(p->pdc, PDF_E_T3_BADBBOX, 0, 0, 0, 0);
 
+
+        if (urx < llx)
+        {
+            tbc = llx;
+            llx = urx;
+            urx = tbc;
+        }
+
+        if (ury < lly)
+        {
+            tbc = lly;
+            lly = ury;
+            ury = tbc;
+        }
+
         if (ig == t3font->capacity)
         {
             t3font->capacity *= 2;
diff -uNr PDFlib-Lite-7.0.4/libs/pdflib/p_util.c PDFlib-Lite-7.0.5/libs/pdflib/p_util.c
--- PDFlib-Lite-7.0.4/libs/pdflib/p_util.c	2009-06-08 17:57:30.000000000 +0200
+++ PDFlib-Lite-7.0.5/libs/pdflib/p_util.c	2010-04-29 15:50:07.000000000 +0200
@@ -10,7 +10,7 @@
  |                                                                           |
  *---------------------------------------------------------------------------*/
 
-/* $Id: p_util.c,v 1.169.2.30 2009/05/28 15:45:42 kurt Exp $
+/* $Id: p_util.c,v 1.169.2.34 2009/10/09 09:35:27 kurt Exp $
  *
  * PDFlib utility functions
  *
@@ -497,7 +497,7 @@
                             &newfilename, &newlen, &htenc, &htcp);
 
     flags |= PDC_CONV_EBCDIC;
-    if (pdc_logg_is_enabled(p->pdc, 3, trc_text))
+    if (pdc_logg_is_enabled(p->pdc, 3, trc_filesearch))
         flags |= PDC_CONV_LOGGING;
 
     resfilename = pdc_convert_filename_ext(p->pdc, newfilename, len,
@@ -573,10 +573,20 @@
                     inev = pdc_get_encoding_vector(p->pdc, enc);
             }
 
-            outev = pdc_get_encoding_vector(p->pdc, pdc_pdfdoc);
+            /* ugly solution of bug #2344 */
+            if (ishypertext == pdc_true)
+            {
+                outev = pdc_get_encoding_vector(p->pdc, pdc_pdfdoc);
 
-            /* conversion to PDFDocEncoding if possible */
-            convflags |= PDC_CONV_TRYBYTES;
+                /* conversion to PDFDocEncoding if possible */
+                convflags |= PDC_CONV_TRYBYTES;
+            }
+            else if (ishypertext == pdc_undef)
+            {
+                /* filename as hypertext */
+                outtextformat = PDC_UTF8;
+                convflags |= PDC_CONV_TRY7BYTES;
+            }
         }
         else
         {
diff -uNr PDFlib-Lite-7.0.4/libs/png/pngconf.h PDFlib-Lite-7.0.5/libs/png/pngconf.h
--- PDFlib-Lite-7.0.4/libs/png/pngconf.h	2009-06-08 17:57:30.000000000 +0200
+++ PDFlib-Lite-7.0.5/libs/png/pngconf.h	2010-04-29 15:50:07.000000000 +0200
@@ -1,4 +1,4 @@
-/* PDFlib GmbH cvsid: $Id: pngconf.h,v 1.15.6.1 2009/06/03 08:53:24 rjs Exp $ */
+/* PDFlib GmbH cvsid: $Id: pngconf.h,v 1.15.6.2 2009/06/30 21:32:43 rjs Exp $ */
 
 /* pngconf.h - machine configurable file for libpng
  *
@@ -231,6 +231,7 @@
  * #define PNG_NO_CONSOLE_IO
  * #define PNG_NO_STDIO
  */
+#define PNG_NO_CONSOLE_IO
 
 #if defined(_WIN32_WCE)
 #  include <windows.h>
diff -uNr PDFlib-Lite-7.0.4/libs/tiff/tif_dir.c PDFlib-Lite-7.0.5/libs/tiff/tif_dir.c
--- PDFlib-Lite-7.0.4/libs/tiff/tif_dir.c	2009-06-08 17:57:30.000000000 +0200
+++ PDFlib-Lite-7.0.5/libs/tiff/tif_dir.c	2010-04-29 15:50:07.000000000 +0200
@@ -1,5 +1,5 @@
 /* PDFlib GmbH cvsid:
- * $Id: tif_dir.c,v 1.20 2005/12/21 14:12:52 rjs Exp $ */
+ * $Id: tif_dir.c,v 1.20.2.1 2010/04/22 13:59:59 tm Exp $ */
 
 /*
  * Copyright (c) 1988-1997 Sam Leffler
@@ -75,6 +75,10 @@
 static int
 setExtraSamples(TIFF* tif, TIFFDirectory* td, va_list ap, uint32* v)
 {
+/* PDFlib GmbH: bug #2424, fix backported from libtiff 4.0.0alpha */
+/* XXX: Unassociated alpha data == 999 is a known Corel Draw bug, see below */
+#define EXTRASAMPLE_COREL_UNASSALPHA 999
+
 	uint16* va;
 	uint32 i;
 
@@ -84,12 +88,25 @@
 	va = va_arg(ap, uint16*);
 	if (*v > 0 && va == NULL)		/* typically missing param */
 		return (0);
-	for (i = 0; i < *v; i++)
-		if (va[i] > EXTRASAMPLE_UNASSALPHA)
-			return (0);
+        for (i = 0; i < *v; i++)
+        {
+                if (va[i] > EXTRASAMPLE_UNASSALPHA) {
+                        /*
+                         * XXX: Corel Draw is known to produce incorrect
+                         * ExtraSamples tags which must be patched here if we
+                         * want to be able to open some of the damaged TIFF
+                         * files:
+                         */
+                        if (va[i] == EXTRASAMPLE_COREL_UNASSALPHA)
+                                va[i] = EXTRASAMPLE_UNASSALPHA;
+                        else
+                                return 0;
+                }
+        }
 	td->td_extrasamples = (uint16) *v;
 	_TIFFsetShortArray(tif, &td->td_sampleinfo, va, td->td_extrasamples);
 	return (1);
+#undef EXTRASAMPLE_COREL_UNASSALPHA
 }
 
 static uint32
diff -uNr PDFlib-Lite-7.0.4/libs/tiff/tif_lzw.c PDFlib-Lite-7.0.5/libs/tiff/tif_lzw.c
--- PDFlib-Lite-7.0.4/libs/tiff/tif_lzw.c	2009-06-08 17:57:31.000000000 +0200
+++ PDFlib-Lite-7.0.5/libs/tiff/tif_lzw.c	2010-04-29 15:50:08.000000000 +0200
@@ -1,5 +1,5 @@
 /* PDFlib GmbH cvsid:
- * $Id: tif_lzw.c,v 1.9 2005/12/21 14:12:52 rjs Exp $ */
+ * $Id: tif_lzw.c,v 1.9.2.1 2009/08/07 10:02:59 tm Exp $ */
 
 /*
  * Copyright (c) 1988-1997 Sam Leffler
@@ -651,6 +651,7 @@
 		}
 		oldcodep = codep;
 		if (code >= 256) {
+			char *op_orig = op;
 			/*
 		 	 * Code maps to a string, copy string
 			 * value to output (written in reverse).
@@ -685,7 +686,7 @@
 			tp = op;
 			do {
 				*--tp = codep->value;
-			} while( (codep = codep->next) != NULL);
+			} while( (codep = codep->next) != NULL && tp > op_orig);
 		} else
 			*op++ = code, occ--;
 	}
diff -uNr PDFlib-Lite-7.0.4/libs/tiff/tif_ojpeg.c PDFlib-Lite-7.0.5/libs/tiff/tif_ojpeg.c
--- PDFlib-Lite-7.0.4/libs/tiff/tif_ojpeg.c	2009-06-08 17:57:31.000000000 +0200
+++ PDFlib-Lite-7.0.5/libs/tiff/tif_ojpeg.c	2010-04-29 15:50:08.000000000 +0200
@@ -1,5 +1,5 @@
 /* PDFlib GmbH cvsid:
- * $Id: tif_ojpeg.c,v 1.27.2.7 2009/05/29 12:38:36 tm Exp $ */
+ * $Id: tif_ojpeg.c,v 1.27.2.9 2009/08/07 15:34:18 tm Exp $ */
 #include "tiffiop.h"
 #ifdef OJPEG_SUPPORT
 
@@ -2079,7 +2079,7 @@
                 sp->jpegproc=(uint16)v32;
                 break;
             case TIFFTAG_JPEGIFOFFSET:
-                sp->jpegifoffset=(uint16)v32;
+                sp->jpegifoffset=v32;
 		break;
             case TIFFTAG_JPEGIFBYTECOUNT:
 		sp->jpegifbytecount=v32;
@@ -2234,6 +2234,14 @@
           if (v32)
             { uint32 *v;
               int i;
+	      if (v32 > td->td_samplesperpixel)
+	      {
+		  _TIFFError(tif, tif->tif_name,
+		    "Too many quantization tables, ignoring excess tables");
+		    /* Read only required number of tables */
+		    v32 = td->td_samplesperpixel;
+	      }
+
               if (v32 > NUM_QUANT_TBLS)
                 {
                   _TIFFError(tif, tif->tif_name,"Too many quantization tables");
